module Pretzel
  module Routing
    module Methods
      
      %w(get post delete put options head).each do |verb|
        define_method(verb) do |route, &block|
          routes[verb.to_sym] << [compile_route(route), block]
        end
      end

      %w(before after).each do |filter|
        define_method(filter) do |&block|
          filters[filter.to_sym] ||= Array.new
          filters[filter.to_sym] << block
        end
      end

      def error(code, &block)
        routes[code] << ["", block]
      end
    end
  end
end